## critnib 1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(critnib C)

set(THREADS_PREFER_PTHREAD_FLAG TRUE)
include(FindThreads)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif (NOT CMAKE_BUILD_TYPE)

set(CMAKE_C_FLAGS "-Wall -Werror=format-security ${CMAKE_C_FLAGS}")

add_library(critnib SHARED critnib.c)
set(libs critnib ${CMAKE_THREAD_LIBS_INIT})
add_executable(m main.c)
target_link_libraries(m ${libs})

set_target_properties(critnib PROPERTIES
	SOVERSION 1
	PUBLIC_HEADER "critnib.h")

include(GNUInstallDirs)
install(TARGETS critnib
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/)
install(FILES critnib.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/libcritnib.3
	critnib.3
	DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)

enable_testing()
add_subdirectory(tests)

add_custom_target(man ALL
	BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/libcritnib.3
	COMMENT "Building libcritnib.3"
	COMMAND pod2man -c critnib -s 3 -n libcritnib
		<${CMAKE_CURRENT_SOURCE_DIR}/libcritnib.pod
		>${CMAKE_CURRENT_BINARY_DIR}/libcritnib.3
	)

=== tests/CMakeLists.txt ===
function(test name)
	add_executable(${name} ${name}.c hmload.c rand.c)
	add_test(${name} ${name})
	set_target_properties(${name} PROPERTIES COMPILE_FLAGS -fcommon)
	target_link_libraries(${name} ${libs})
endfunction()

test(1corr)
test(inequal)
test(th)

=== debian/changelog ===
critnib (1.0-1) unstable; urgency=medium

  * Initial release (Closes: #994958)

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 24 Sep 2021 01:36:42 +0200

=== debian/control ===
Source: critnib
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/kilobyte/critnib
Vcs-Browser: https://github.com/kilobyte/critnib/tree/debian
Vcs-Git: https://github.com/kilobyte/critnib -b debian
Rules-Requires-Root: no
Description: ordered map data structure with lock-free reads
 Critnib is a data structure that provides a very fast equal and
 less-than/greater-than searches; it is a mix between DJBerstein's
 critbit and radix trees.  While in bad cases it has worse memory use
 than binary trees, it works well on real-life data which tends to
 have a limited number of "decision bits":
  * fully random: divergence happens immediately
  * malloc addresses: clumps of distinct bits in the middle
  * sequences: only lowest bits are filled
 .
 This library ships only uintptr_t→uintptr_t mappings, optimized for
 reads from a very critical section but not so frequent writes.  Other
 variants also exist (such as fully lock-free writes, keys of arbitrary
 length), and can be added upon request.

Package: libcritnib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcritnib1 (= ${binary:Version}), ${misc:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the development headers.

Package: libcritnib1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}

## critnib 1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 set(CMAKE_C_FLAGS "-Wall -Werror=format-security ${CMAKE_C_FLAGS}")
 
 add_library(critnib SHARED critnib.c)
-set(libs critnib ${CMAKE_THREAD_LIBS_INIT})
+set(libs critnib ${CMAKE_THREAD_LIBS_INIT} -latomic)
 add_executable(m main.c)
 target_link_libraries(m ${libs})
 
@@ -33,10 +33,10 @@
 enable_testing()
 add_subdirectory(tests)
 
-add_custom_target(man ALL
-	BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/libcritnib.3
-	COMMENT "Building libcritnib.3"
+add_custom_command(OUTPUT libcritnib.3
+	DEPENDS libcritnib.pod
 	COMMAND pod2man -c critnib -s 3 -n libcritnib
 		<${CMAKE_CURRENT_SOURCE_DIR}/libcritnib.pod
-		>${CMAKE_CURRENT_BINARY_DIR}/libcritnib.3
-	)
+		>${CMAKE_CURRENT_BINARY_DIR}/libcritnib.3)
+add_custom_target(man ALL
+	DEPENDS libcritnib.3)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -8,3 +8,7 @@
 test(1corr)
 test(inequal)
 test(th)
+
+add_executable(iter-cli iter-cli.c)
+target_link_libraries(iter-cli ${libs})
+add_test(iter ${CMAKE_CURRENT_SOURCE_DIR}/iter)

=== debian/changelog ===
critnib (1.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1112812)

 -- Adrian Bunk <bunk@debian.org>  Sat, 18 Oct 2025 22:11:14 +0300

critnib (1.1-2) unstable; urgency=medium

  * Fix the autopkgtest on 32-bit.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 04 Dec 2021 20:49:01 +0100

critnib (1.1-1) unstable; urgency=medium

  * New upstream release.
  * Add an autopkgtest.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 28 Nov 2021 17:20:06 +0100

critnib (1.0-2) unstable; urgency=medium

  * Add -latomic to make armel/mipsel/m68k/powerpc/sh4 happy.
  * Don't try to detect SMP on Hurd, there's none.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 16 Nov 2021 02:42:54 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
 Build-Depends: debhelper-compat (= 13), cmake
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: libs
 Homepage: https://github.com/kilobyte/critnib
 Vcs-Browser: https://github.com/kilobyte/critnib/tree/debian

=== debian/tests/control ===
Test-Command: cc -Wall -o "$AUTOPKGTEST_TMP"/⁊ debian/tests/basic.c -lcritnib && "$AUTOPKGTEST_TMP"/⁊
Features: test-name=basic
Depends: gcc, libc-dev, libcritnib-dev

Test-Command: cc -Wall -o "$AUTOPKGTEST_TMP"/⁊ debian/tests/basic.c -lcritnib && valgrind --error-exitcode=1 -q "$AUTOPKGTEST_TMP"/⁊
Features: test-name=basic-valgrind
Depends: gcc, libc-dev, libcritnib-dev, valgrind
Restrictions: skip-not-installable

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%critnib-$1.tar.gz%" \
   https://github.com/kilobyte/critnib/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
